using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Edu.Model.Entity.Mall;
using Edu.Model.ViewModel.Mall;

namespace Edu.Repository.Mall
{
   public class RB_Goods_CategoryRepository:BaseRepository<RB_Goods_Category>
    {
        /// <summary>
        /// 列表
        /// </summary>
        /// <param name="dmodel">查询条件</param>
        /// <returns></returns>
        public List<RB_Goods_Category_Extend> GetList(RB_Goods_Category_Extend dmodel)
        {
            string where = $" 1=1 and gc.{nameof(RB_Goods_Category.Status)}=0";
            if (dmodel.TenantId > 0)
            {
                where += $@" and gc.{nameof(RB_Goods_Category.TenantId)}={dmodel.TenantId}";
            }
            if (dmodel.MallBaseId > 0)
            {
                where += $@" and gc.{nameof(RB_Goods_Category.MallBaseId)}={dmodel.MallBaseId}";
            }
            if (dmodel.Id > 0)
            {
                where += $@" and gc.{nameof(RB_Goods_Category.Id)}={dmodel.Id}";
            }
            if (dmodel.GoodsId > 0)
            {
                where += $@" and gc.{nameof(RB_Goods_Category.GoodsId)}={dmodel.GoodsId}";
            }
            if (!string.IsNullOrEmpty(dmodel.GoodsIds))
            {
                where += $@" and gc.{nameof(RB_Goods_Category.GoodsId)} in({dmodel.GoodsIds})";
            }
            if (dmodel.CategoryId > 0)
            {
                where += $@" and gc.{nameof(RB_Goods_Category.CategoryId)}={dmodel.CategoryId}";
            }

            string sql = $@"
SELECT gc.*,pc.Name as CategoryName,pc.IsForeignShare,pc.ParentId,pc.Tier
FROM RB_Goods_Category gc inner join rb_product_category pc on gc.CategoryId=pc.Id
WHERE {where} ORDER BY gc.Id DESC ";
            return Get<RB_Goods_Category_Extend>(sql).ToList();
        }
    }
}
